#
# spec file for package libffi43
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#
# icecream 0


%define building_libffi 1
# spec file for package gcc43 (Version 4.3.x)
#
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# Run the testsuite if there's a file named RUN_TESTS in the source
%if 0%{!?run_tests:1}
%define run_tests %(test -f %_sourcedir/RUN_TESTS && echo 1 || echo 0)
%endif

# Ada currently fails to build on a few platforms, enable it only
# on those that work
# Note that AdaCore only supports %ix86, x86_64 and ia64
%ifarch %ix86 x86_64 ppc s390 ia64
%define build_ada !0%{?building_libjava:1}%{?building_libffi:1}
%else
# alpha ppc64 s390x hppa
%define build_ada 0
%endif

# too recent distros don't provide gcc43-ada anymore
# which we'd need for building our Ada
%if %{suse_version} >= 1315
%define build_ada 0
%endif

# We don't want to build java on arm
%ifarch mips %arm
%define build_java 0
%define build_libjava 0
%else
%define build_java 1
%define build_libjava 0%{?building_libjava:1}%{?building_libffi:1}
%endif

%define build_cp 1
%define build_fortran 1
%define build_objc 1
%define build_objcp !0%{?building_libjava:1}%{?building_libffi:1}
%define build_with_mudflap 0

%if %{build_objcp}
%define build_cp 1
%define build_objc 1
%endif

%if %{build_libjava}
%define build_cp 1
%endif

%if %{suse_version} >= 1220
%define selfconflict() %1
%else
%define selfconflict() otherproviders(%1)
%endif

Name:           libffi43
ExcludeArch:    %arm
BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  gettext-devel
BuildRequires:  glibc-devel-32bit glibc-32bit
BuildRequires:  mpfr-devel
BuildRequires:  perl
BuildRequires:  zlib-devel
%if %{suse_version} > 1220
BuildRequires:  makeinfo
%else
BuildRequires:  texinfo
%endif
%if %{build_ada}
%if %{suse_version} > 1110
%define hostsuffix -4.3
BuildRequires:  gcc43-ada
%else
%define hostsuffix %{nil}
BuildRequires:  gcc-ada
%endif
%endif
%if %{build_libjava}
%if 0%{!?building_libffi:1}
BuildRequires:  fastjar
BuildRequires:  gtk2-devel
BuildRequires:  libart_lgpl-devel
BuildRequires:  unzip
BuildRequires:  xorg-x11-devel
%endif
%endif
%ifarch ia64
BuildRequires:  libunwind-devel
%endif
%if %{run_tests}
BuildRequires:  dejagnu
BuildRequires:  expect
%endif

# Define version number of libgcc_s
%ifarch hppa
%define libgcc_s 4
%else
%define libgcc_s 1
%endif
%ifarch ppc
# We support building the nof libraries, but don't want this in the
# regular rpms
%define build_nof 0
%else
%define build_nof 0
%endif

%define separate_bi32 0
%define separate_bi64 0
%ifarch ppc
# Beware, this does _not_ separate libgcj, as for that one multilibing
# is inactive for the time being
%define separate_bi64 1
%endif
%ifarch x86_64 s390x ppc64
%define separate_bi32 1
%endif

# Define two macros to trigger -32bit or -64bit package variants
%define separate_biarch 0
%if %{separate_bi32}
%define separate_biarch 1
%define separate_biarch_suffix -32bit
%endif
%if %{separate_bi64}
%define separate_biarch 1
%define separate_biarch_suffix -64bit
%endif

%ifarch x86_64 ia64 s390x alpha ppc64
# 64-bit is primary build target
%define build_primary_64bit 1
%else
%define build_primary_64bit 0
%endif

%define biarch_libjava 0

%define biarch_targets x86_64 s390x powerpc64 powerpc

URL:            http://gcc.gnu.org/
Version:        4.3.4_20091019
Release:        63.1
%define gcc_version %(echo %version | sed 's/_.*//')
%define gcc_dir_version %(echo %gcc_version | cut -d '.' -f 1-2)
%define snapshot_date %(echo %version | sed 's/[34]\.[0-4]\.[0-6]//' | sed 's/_/-/')
%define binsuffix -4.3

%if !0%{?building_libjava:1}%{?building_libffi:1}
Requires:       binutils
Requires:       cpp43 = %{version}-%{release}
Requires:       glibc-devel
Requires:       libgcc_s%{libgcc_s} >= %{version}-%{release}
Requires:       libgomp1 >= %{version}-%{release}
%if %{build_with_mudflap}
Requires:       libmudflap0 >= %{version}-%{release}
Requires:       libmudflapth0 >= %{version}-%{release}
%endif
%if 0%{suse_version} > 1000
Suggests:       gcc43-info gcc43-locale
%endif
%endif

BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         gcc-%{gcc_version}%{snapshot_date}.tar.bz2
Source1:        change_spec
Source2:        libgcj43-rpmlintrc
Source3:        gcc43-rpmlintrc
Source4:        ecj.jar
Source5:        README.First-for.SuSE.packagers
Source6:        baselibs.conf
Patch1:         gcc-dir-version.patch
Patch2:         gcc-sles-version.patch
Patch3:         gcc-noalias-warn.diff
Patch4:         gcc-add-defaultsspec.diff
Patch5:         boehm-gc-strict-aliasing.patch
Patch6:         suse-record-gcc-opts.diff
Patch7:         acats-timeout.patch
Patch10:        program-transform-name.diff
Patch11:        program-transform-name-tools.diff
Patch12:        gcc4-ppc64-m32-m64-multilib-only.patch
Patch22:        libjava-no-static.diff
Patch23:        libjava-no-multilib.diff
Patch24:        tls-no-direct.diff
Patch25:        pr27880.diff
Patch28:        pr33763.diff
Patch29:        pr40141.diff
Patch30:        Wunprototyped-calls.diff
Patch31:        pr27799-1.diff
Patch32:        pr27799-2.diff
Patch33:        pr27799-3.diff
Patch41:        fpreserve-function-arguments43.patch
Patch42:        pr27975.diff
Patch43:        build-id.diff
Patch44:        nvl428413.patch
Patch45:        nvl423594.patch
Patch46:        pr32277.diff
Patch47:        gcc43-as-g0
Patch48:        pr38591.diff
Patch49:        nvl775482.patch
Patch250:       gcc43-lfs-support.patch
Patch202:       nvl440482.patch
Patch204:       pr39675.diff
Patch205:       pr42429.diff
Patch206:       pr42614.diff
Patch207:       pr45502.diff
Patch208:       pr47278.diff
Patch209:       nvl675609.patch
Patch210:       nvl665849.patch
Patch211:       gcc43-better-debuginfo.diff
Patch212:       gcc43-better-debuginfo-2.diff
Patch213:       nvl799300.patch
Patch214:       nvl938159.patch
Patch215:       gcc-unwind-glibc216.patch
Patch216:       gcc43-bnc977654.patch
Patch217:       gcc43-nvl999596.patch
Patch218:       gcc43-bnc1044016.patch
Patch219:       gcc43-libffi-noexecstack.diff
Patch220:       gcc43-stack-probe.diff
# A set of patches from the RH srpm
Patch50:        gcc43-c++-builtin-redecl.patch
Patch51:        gcc41-ia64-stack-protector.patch
Patch52:        gcc43-java-debug-iface-type.patch
Patch53:        gcc43-libgomp-omp_h-multilib.patch
Patch54:        gcc43-pr34037.patch
Patch55:        gcc41-java-slow_pthread_self.patch
Patch56:        gcc43-pr36741-revert.patch
Patch57:        gcc41-ppc32-retaddr.patch
Patch58:        gcc43-pr37189.patch
Patch59:        gcc43-x86_64-va_start.patch
# Some patches taken from Debian
Patch60:        gcc43-textdomain.patch
Patch61:        gcc43-rename-info-files.patch
# Patches for AMD features
Patch70:        pr34043-1.diff
Patch71:        pr34043-2.diff
Patch72:        pr34043-3.diff
Patch73:        pr34043-4.diff
Patch74:        pr34043-5.diff
Patch75:        amd-SSE5-shift-ppc-1.diff
Patch76:        amd-SSE5-shift-ppc-2.diff
Patch77:        amd-SSE5-shift.diff
Patch78:        amd-cunroll-1.diff
Patch79:        amd-cunroll-2.diff
Patch81:        amd-cvect-1.diff
Patch82:        amd-cvect-2.diff
# Patches for Intel features
Patch80:        intel303993-aes.diff
# Patches for IBM features
Patch90:        ibm304071-z10-1
Patch91:        ibm304071-z10-2
Patch92:        ibm304071-z10-3
Patch93:        ibm304071-z10-4
Patch94:        ibm304071-z10-5
Patch95:        ibm304071-z10-6
Patch96:        pr36745.diff
Patch97:        pr36822.diff
Patch99:        ibm-vector-keyword-1
Patch100:       ibm-vector-keyword-2
Patch101:       ibm-vector-keyword-3
Patch102:       diff-z6-scheduling
Patch103:       ibm304134-power7-1
Patch104:       ibm-cell-split
Patch105:       ibm-cell-split-fixes
Patch106:       nvl425806.patch
Patch109:       nvl425783.patch
Patch110:       nvl425784.patch
Patch111:       nvl425788.patch
Patch112:       nvl425789.patch
Patch114:       nvl425791.patch
Patch115:       nvl425794.patch
Patch116:       nvl425798-1.patch
Patch117:       nvl425798-2.patch
Patch118:       nvl425799.patch
Patch119:       nvl426087.patch
Patch120:       ibm304071-z10-8
Patch121:       nvl434500.patch
Patch122:       nvl436041.patch
Patch123:       gcc43-no-unwind-tables.diff
Patch124:       nvl441016.patch
Patch126:       nvl447669.diff
Patch127:       nvl464739.patch
Patch128:       ibm434505-spu
Patch1281:      nvl712118.patch
Patch129:       nvl623386.patch
# Patches for SAP features
Patch130:       sap303956-utf16-1.diff
Patch131:       sap303956-utf16-2.diff
Patch132:       sap303956-utf16-3.diff
Patch133:       sap303956-utf16-4.diff
Patch134:       sap303956-utf16-mangling.diff
# Patches for SP1 IBM features
Patch140:       z10-IJ-constraints
Patch141:       s390-mvc-mov
Patch142:       z10-sched-fixes1
Patch143:       z10-sched-fixes3
Patch144:       z10-sched-fixes4
Patch145:       diff-vortex-1
Patch146:       s390-address-constraints
Patch147:       true-comp-z10
Patch148:       s390-max-unroll-insn-default
Patch149:       s390-long-loop-prediction-1
Patch150:       z10-cost
Patch151:       stcmh-fix
Patch152:       diff-symref-align-constpool
Patch160:       gcc-power7-sles-11sp1.patch02a
Patch162:       gcc-power7-sles-11sp1.patch02c
Patch163:       gcc-power7-sles-11sp1.patch02d
Patch164:       gcc-power7-sles-11sp1.patch02e
Patch165:       gcc-power7-sles-11sp1.patch02f
Patch166:       gcc-power7-sles-11sp1-nvl572812.patch
Patch167:       gcc-power7-sles-11sp1-bnc729378.patch
# Patches for SP2 IBM features
Patch170:       ibm311554-ltoc-r157731:157732
Patch171:       ibm311554-ltoc-r160772:160773
Patch172:       ibm311554-ltoc-r160977:160978
Patch173:       ibm311554-ltoc-r161370:161371
Patch174:       ibm311554-ltoc-r164044:164046
Patch175:       ibm311554-ltoc-r164552:164553
Patch176:       ibm311554-ltoc-r169076:169077
Patch177:       ibm311554-ltoc-r169426:169427
Patch178:       ibm311554-ltoc-r170605:170606
Patch179:       ibm311554-ltoc-r170975:170976
Patch180:       ibm311554-ltoc-r171904:171905
Patch181:       ibm311554-ltoc-cmodel_small.diff
Patch182:       s390-fmadd-2mem
Patch183:       prefetch-schedule-barrier
Patch184:       s390-z10-bypasses
Patch185:       s390-remove-copysign
Patch187:       s390-movqi-memmem
Patch188:       s390-memxxx-prefetchs
Patch189:       s390-option-defaults
Patch190:       loop-unroll-adjust
Patch191:       s390-31bit-sibcall-fix
Patch192:       s390-peel-times-default
Patch193:       s390-movqi-typo
Patch194:       s390-remove-loadfpzero
Patch195:       s390-fix-z10prop
Patch196:       s390-literalpool-qrst
Patch197:       s390-improve-loadfpzero
Patch198:       s390-literalpool-cse
Patch199:       s390-symref-preferredreload
Patch200:       nvl702947-power7-vsx-abi.patch
Patch201:       nvl760808.patch
# Trunk backport
Patch221:       gcc43-mindirect-branch.diff

Summary:        Foreign Function Interface library
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Provides:       g-wrap:/usr/lib/libffi.so.4
Provides:       libffi4 = %{version}-%{release}
Obsoletes:      libffi4 < %{version}-%{release}
# make rpm happy
Obsoletes:      libffi41
Obsoletes:      libffi42
# make zypp happy
Provides:       libffi41
Provides:       libffi42

%description 
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%post -n libffi43 -p /sbin/ldconfig

%postun -n libffi43 -p /sbin/ldconfig
%package -n libffi43-32bit
Summary:        Foreign Function Interface library
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Provides:       g-wrap:/usr/lib/libffi.so.4
Provides:       libffi4 = %{version}-%{release}
Obsoletes:      libffi4 < %{version}-%{release}
# make rpm happy
Obsoletes:      libffi41-32bit
Obsoletes:      libffi42-32bit
# make zypp happy
Provides:       libffi41-32bit
Provides:       libffi42-32bit

%description -n libffi43-32bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%post -n libffi43-32bit -p /sbin/ldconfig

%postun -n libffi43-32bit -p /sbin/ldconfig
%package -n libffi43-64bit
Summary:        Foreign Function Interface library
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Provides:       g-wrap:/usr/lib/libffi.so.4
Provides:       libffi4 = %{version}-%{release}
Obsoletes:      libffi4 < %{version}-%{release}
# make rpm happy
Obsoletes:      libffi41-64bit
Obsoletes:      libffi42-64bit
# make zypp happy
Provides:       libffi41-64bit
Provides:       libffi42-64bit

%description -n libffi43-64bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%post -n libffi43-64bit -p /sbin/ldconfig

%postun -n libffi43-64bit -p /sbin/ldconfig

%package -n libffi43-devel
Summary:        Foreign Function Interface library development files
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Requires:       libffi43 >= %{version}-%{release}

%description -n libffi43-devel
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.
%package -n libffi43-devel-32bit
Summary:        Foreign Function Interface library development files
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Requires:       libffi43-32bit >= %{version}-%{release}

%description -n libffi43-devel-32bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.
%package -n libffi43-devel-64bit
Summary:        Foreign Function Interface library development files
License:        BSD-3-Clause
Group:          Development/Languages/C and C++
Requires:       libffi43-64bit >= %{version}-%{release}

%description -n libffi43-devel-64bit
A foreign function interface is the popular name for the interface that allows code written in one language to call code written in another language.

%package -n gcc43-testresults
Summary:        Testsuite results
License:        SUSE-Public-Domain
Group:          Development/Languages/C and C++

%description -n gcc43-testresults
Results from running the gcc and target library testsuites.



# Define the canonical target and host architecture
#   %gcc_target_arch  is supposed to be the full target triple
#   %TARGET_ARCH      is the canonicalized CPU part
#   %CONFIGURE_TARGET is the target triple used for --target=
%if 0%{?gcc_target_arch:1}
%define CONFIGURE_TARGET %{gcc_target_arch}
%define TARGET_ARCH %(echo %{gcc_target_arch} | cut -d - -f 1 | sed -e "s/i.86/i586/;s/ppc/powerpc/")
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "powerpc"
%define CONFIGURE_TARGET powerpc64-linux
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "powerpc64"
%define CONFIGURE_TARGET powerpc64-linux
%endif
%if 0%{?gcc_icecream:1} && %{TARGET_ARCH} == "i586"
%define CONFIGURE_TARGET i586-linux
%endif
%else
%define TARGET_ARCH %(echo %{_target_cpu} | sed -e "s/i.86/i586/;s/ppc/powerpc/")
%endif
%define HOST_ARCH %(echo %{_host_cpu} | sed -e "s/i.86/i586/;s/ppc/powerpc/")

%define biarch %(case " %{biarch_targets} " in (*" %{TARGET_ARCH} "*) echo 1;; (*) echo 0;; esac)

%ifarch ppc
%define GCCDIST powerpc64-suse-linux
%else
%define GCCDIST %{HOST_ARCH}-suse-linux
%endif

%define libsubdir %{_libdir}/gcc/%{GCCDIST}/%{gcc_dir_version}
%define gxxinclude %{_prefix}/include/c++/%{gcc_dir_version}

# Versionspecific directories
%define versmainlibdir %{libsubdir}
%define versmainlibdirbi32 %{libsubdir}/32
%define versmainlibdirbi64 %{libsubdir}/64
%ifarch ppc
%define versnoflibdir %{libsubdir}/nof
%define versmainlibdirbi32 %{libsubdir}
%define versmainlibdirbi64 %{libsubdir}/64
%endif
%ifarch ppc64
%define versnoflibdir %{libsubdir}/32/nof
%endif
%if %{build_primary_64bit}
%define versmainlibdirbi %{versmainlibdirbi32}
%else
%define versmainlibdirbi %{versmainlibdirbi64}
%endif

%define mainlibdir %{_libdir}
%define mainlibdirbi32 %{_prefix}/lib
%define mainlibdirbi64 %{_prefix}/lib64
%define noflibdir %{_prefix}/lib/nof
%if %{build_primary_64bit}
%define mainlibdirbi %{mainlibdirbi32}
%else
%define mainlibdirbi %{mainlibdirbi64}
%endif

# Now define a few macros that make it easy to package libs and
# related files just to the right package, without caring for the
# exact path the files are in.
#   %mainlib  package X from all dirs that belong to the main package
#   %biarchlib   package X from all dirs that belong to the -32/64bit package
# by default, nof libs go where the 32bit libs go.
%if %{build_nof}
%define mainlib() %{mainlibdir}/%1\
%{noflibdir}/%1\
%{nil}
%else
%define mainlib() %{mainlibdir}/%1\
%{nil}
%endif
%define biarchlib() %{nil}
%if %{biarch}
%if !%{separate_biarch}
%if %{build_nof}
%define mainlib() %{mainlibdir}/%1\
%{mainlibdirbi}/%1\
%{noflibdir}/%1\
%{nil}
%else
%define mainlib() %{mainlibdir}/%1\
%{mainlibdirbi}/%1\
%{nil}
%endif
%else
%if %{build_nof}
%define biarchlib() %{mainlibdirbi}/%1\
%{noflibdir}/%1\
%{nil}
%define mainlib() %{mainlibdir}/%1\
%{nil}
%else
%define biarchlib() %{mainlibdirbi}/%1\
%{nil}
%endif
%endif
%endif

%if %{build_nof}
%define versmainlib() %{versmainlibdir}/%1\
%{versnoflibdir}/%1\
%{nil}
%else
%define versmainlib() %{versmainlibdir}/%1\
%{nil}
%endif
%define versbiarchlib() %{nil}
%if %{biarch}
%if !%{separate_biarch}
%if %{build_nof}
%define versmainlib() %{versmainlibdir}/%1\
%{versmainlibdirbi}/%1\
%{versnoflibdir}/%1\
%{nil}
%else
%define versmainlib() %{versmainlibdir}/%1\
%{versmainlibdirbi}/%1\
%{nil}
%endif
%else
%if %{build_nof}
%define versbiarchlib() %{versmainlibdirbi}/%1\
%{versnoflibdir}/%1\
%{nil}
%define versmainlib() %{versmainlibdir}/%1\
%{nil}
%else
%define versbiarchlib() %{versmainlibdirbi}/%1\
%{nil}
%endif
%endif
%endif

%prep
%setup -q -n gcc-%{gcc_version}%{snapshot_date}
%patch1
# This patch changes the version string reported by GCC from
# gcc (SUSE Linux) 4.3.2 20080806 (prerelease) [gcc-4_3-branch revision 138797]
# to
# gcc (SUSE Linux) 4.3.1 [gcc-4_3-branch revision 138797]
# as requested by bnc#363219.
%patch2
%patch3
%patch4
%patch5
%if 0%{suse_version} > 1100
%patch6
%endif
%patch7
%patch10
%patch11
%if !%{build_nof}
%patch12
%endif
%patch22
%patch23
%patch24
%patch25
%patch28
%patch29
%patch30
%patch31
%patch32
%patch33
%patch41
%patch42
%if 0%{suse_version} > 1100
%patch43
%endif
%patch44
%patch45
%patch46
%patch47
%patch48
%patch49
%patch250
%patch202
%patch204
%patch205
%patch206
%patch207 -p1
%patch208
%patch209
%patch210
%patch211
%patch212
%patch213 -p1
%patch214
%patch215 -p1
%patch216
%patch217
%patch218
%patch219
%patch220
%patch50
%patch51
%patch52
%patch53
%patch54
%patch55
%patch56
%patch57
%patch58
%patch59
%patch60
%patch61
%patch70
%patch71
%patch72
%patch73
%patch74 -p1
%patch75
%patch76
%patch77
%patch78
%patch79
%patch81
%patch82
%patch80
%patch90
%patch91
%patch92
%patch93
%patch94
%patch95
%patch96
%patch97
%patch99
%patch100
%patch101
%patch102
%patch103
%patch104 -p1
%patch105 -p1
%patch106
%patch109
%patch110
%patch111
%patch112
%patch114
%patch115
%patch116
%patch117
%patch118
%patch119
%patch120
%patch121
%patch122
%patch123
%patch124 -p1
%patch126
%patch127
%patch128
%patch1281
%patch129
%patch130
%patch131
%patch132
%patch133
%patch134
%patch140 -p1
%patch141
%patch142
%patch143
%patch144
%patch145
%patch146
%patch147
%patch148
%patch149
%patch150
%patch151
%patch152
%patch160 -p1
%patch162 -p1
%patch163 -p1
%patch164 -p1
%patch165 -p1
%patch166
%patch167
%patch170
%patch171
%patch172
%patch173
%patch174
%patch175
%patch176
%patch177
%patch178
%patch179
%patch180
%patch181
%patch182
%patch183
%patch184
%patch185
%patch187
%patch188
%patch189
%patch190
%patch191
%patch192
%patch193
%patch194
%patch195
%patch196
%patch197
%patch198
%patch199
%patch200 -p1
%patch201
%patch221 -p1

%build
# Avoid rebuilding of generated files
contrib/gcc_update --touch

# Split version file into version used for directories (X.Y) and
# version to report with --version (X.Y.Z).
# See also gcc-dir-version.patch.
# Also decrement the patchlevel version by one
if test `cat gcc/DEV-PHASE` == "prerelease"; then
  ( cat gcc/BASE-VER | cut -d '.' -f 1-2 | tr -d '\n'; echo -n .; cat gcc/BASE-VER | cut -d '.' -f 3 | tr '0123456789' '0012345678' ) > gcc/FULL-VER
else
  mv gcc/BASE-VER gcc/FULL-VER
fi
cat gcc/FULL-VER | cut -d '.' -f 1-2 > gcc/BASE-VER

rm -rf obj-%{GCCDIST}
mkdir obj-%{GCCDIST}
cd obj-%{GCCDIST}
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -U_FORTIFY_SOURCE"
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-Wmissing-format-attribute//g' -e 's/-fstack-protector[^ ]*//g' -e 's/-ffortify=.//g' -e 's/-Wall//g' -e 's/-m32//g' -e 's/-m64//g' -e 's/-grecord-gcc-switches//g'`
%ifarch %ix86
# -mcpu is superceded by -mtune but -mtune is not supported by
# our bootstrap compiler.  -mcpu gives a warning that stops
# the build process, so remove it for now.
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-mcpu=i.86//g'`
%endif
%ifarch s390 s390x
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fsigned-char//g'`
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-O1/-O2/g'`
%endif
%if 0%{?gcc_target_arch:1} && 0%{!?gcc_icecream:1}
# Kill all -march/tune/cpu because that screws building the target libs
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-m\(arch\|tune\|cpu\)=[^ ]*//g'`
%endif
# Replace 2 spaces by one finally
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/  / /g'`

languages=c
%if %{build_cp}
languages=$languages,c++
%endif
%if %{build_objc}
languages=$languages,objc
%endif
%if %{build_fortran}
languages=$languages,fortran
%endif
%if %{build_objcp}
languages=$languages,obj-c++
%endif
%if %{build_java}
languages=$languages,java
%endif
%if %{build_ada}
languages=$languages,ada
%endif

J=%{?jobs:%jobs}
if test -z "$J"; then
  J=$(getconf _NPROCESSORS_CONF)
  JL=$(($J * 2))
else
  test 1 -gt "$J" && J=1
  JL=$(($(getconf _NPROCESSORS_CONF)*2))
fi
if test "$J" == "0"; then
  J=1
fi
if test "$JL" == "0"; then
  JL=1
fi
PARALLEL="-j$J -l$JL"

# we don't want some miscompiles in the testsuite, or some fault in
# the compiler to kill the machine.  Hence we limit the amount of memory
# by the physical RAM plus half of swap
#MEM=$(free -m | awk '/^Mem:/ {print $2}')
#SWAP=$(free -m | awk '/^Swap:/ {print $2}')
#ulimit -v $(((MEM + SWAP/2)*1024))

# In general we want to ship release checking enabled compilers
# and run BETA with checking enabled.
#ENABLE_CHECKING="--enable-checking=yes"
ENABLE_CHECKING="--enable-checking=release"

%if "%{name}" != "gcc43"
export PATH=/opt/cross/bin:$PATH
%endif

# Work around tail/head -1 changes
export _POSIX2_VERSION=199209

# -Wl,-as-needed breaks the libgcj setup
export SUSE_ASNEEDED=0

# configure tries to parse include/features.h to detect
# if glibc supports SSP.  When cross compiling we would need
# to install a cross glibc, which we don't, or make the whole
# thing point to the native glibc, which is in /, hence the
# --with-sysroot=/

%if %{build_ada}
# Using the host gnatmake like
#   CC="gcc%{hostsuffix}" GNATBIND="gnatbind%{hostsuffix}"
#   GNATMAKE="gnatmake%{hostsuffix}"
# doesn't work due to PR33857, so an un-suffixed gnatmake has to be
# available
mkdir -p host-tools/bin
cp -a /usr/bin/gnatmake%{hostsuffix} host-tools/bin/gnatmake
cp -a /usr/bin/gnatlink%{hostsuffix} host-tools/bin/gnatlink
cp -a /usr/bin/gnatbind%{hostsuffix} host-tools/bin/gnatbind
cp -a /usr/bin/gcc%{hostsuffix} host-tools/bin/gcc
ln -sf /usr/%{_lib} host-tools/%{_lib}
export PATH="`pwd`/host-tools/bin:$PATH"
%endif
#%if 0%{?gcc_target_arch:1} && 0%{!?gcc_icecream:1}
#%else
#	--enable-threads=posix \
#%endif
#	--enable-shared \
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" GCJFLAGS="$RPM_OPT_FLAGS" \
../configure \
	--prefix=%{_prefix} \
	--infodir=%{_infodir} \
	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
	--enable-languages=$languages \
	$ENABLE_CHECKING \
	--with-gxx-include-dir=%{_prefix}/include/c++/%{gcc_dir_version} \
	--enable-ssp \
	--disable-libssp \
	--with-bugurl="http://bugs.opensuse.org/" \
	--with-pkgversion="SUSE Linux" \
%if !%{build_libjava}
        --disable-libgcj \
%else
	--with-java-home=%{_libdir}/jvm/java-1.5.0-gcj%{binsuffix}-1.5.0.0/jre \
	--with-ecj-jar=%{libsubdir}/ecj.jar \
        --enable-java-awt=gtk \
	--enable-gtk-cairo \
%if !%{biarch_libjava}
        --disable-libjava-multilib \
%endif
%endif
%if !%{build_with_mudflap}
	--disable-libmudflap \
%endif
	--with-slibdir=/%{_lib} \
	--with-system-zlib \
	--enable-__cxa_atexit \
	--enable-libstdcxx-allocator=new \
	--disable-libstdcxx-pch \
	--enable-version-specific-runtime-libs \
%if 0%{?gcc_target_arch:1}
%if 0%{?gcc_icecream:1}
	--with-as=/opt/cross/%{TARGET_ARCH}-linux/bin/as \
	--with-ld=/opt/cross/%{TARGET_ARCH}-linux/bin/ld \
	--with-sysroot=/ \
	--enable-linux-futex \
%endif
%if 0%{?build_static:1}
	--disable-shared \
%endif
%if "%{TARGET_ARCH}" == "spu"
	--with-sysroot=/usr/spu \
	--with-gxx-include-dir=%{_prefix}/spu/include/c++/%{gcc_dir_version} \
	--with-newlib \
%endif
	--disable-nls \
	--target=%{CONFIGURE_TARGET} \
%else
	--program-suffix=%{binsuffix} \
	--enable-linux-futex \
%ifarch ia64
	--with-system-libunwind \
%else
	--without-system-libunwind \
%endif
%endif
%if "%{TARGET_ARCH}" == "powerpc"
	--with-cpu=default32 \
	--enable-secureplt \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "powerpc64"
	--with-cpu=power4 \
	--enable-secureplt \
	--with-long-double-128 \
%endif
%if "%{TARGET_ARCH}" == "i586"
	--with-cpu=generic \
%endif
%if "%{TARGET_ARCH}" == "x86_64"
	--with-cpu=generic \
%endif
%if "%{TARGET_ARCH}" == "s390"
        --with-tune=z9-109 --with-arch=z900 \
	--with-long-double-128 \
	--enable-decimal-float \
%endif
%if "%{TARGET_ARCH}" == "s390x"
        --with-tune=z9-109 --with-arch=z900 \
	--with-long-double-128 \
	--enable-decimal-float \
%endif
	--build=%{GCCDIST}

%if 0%{?building_libffi:1}
make all-target-libffi $PARALLEL
%else
# Only run profiled bootstrap on archs where it works
#%ifarch %ix86 x86_64 ppc ppc64 ia64
#%ifarch %ix86 x86_64 ia64 s390 s390x
#make profiledbootstrap-lean BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%else
make bootstrap-lean BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%endif
#make -C gcc proto
make info
%if %{run_tests}
echo "Run testsuite"
(make -C %{GCCDIST}/libstdc++-v3 check-abi || true)
mv %{GCCDIST}/libstdc++-v3/testsuite/libstdc++.log %{GCCDIST}/libstdc++-v3/testsuite/libstdc++-abi.log
mv %{GCCDIST}/libstdc++-v3/testsuite/libstdc++.sum %{GCCDIST}/libstdc++-v3/testsuite/libstdc++-abi.sum
make -k check $PARALLEL || true
mkdir ../testresults
../contrib/test_summary > ../testresults/test_summary.txt
%endif
%endif

%install
export NO_BRP_CHECK_BYTECODE_VERSION=true
cd obj-%{GCCDIST}
# Work around tail/head -1 changes
export _POSIX2_VERSION=199209
export LIBRARY_PATH=$RPM_BUILD_ROOT%{libsubdir}:$RPM_BUILD_ROOT%{mainlibdirbi}
%if 0%{?building_libffi:1}
make -C %{GCCDIST}/libffi install DESTDIR=$RPM_BUILD_ROOT
%else
%if 0%{?building_libjava:1}
make -C %{GCCDIST}/libjava install DESTDIR=$RPM_BUILD_ROOT
make -C gcc java.install-man DESTDIR=$RPM_BUILD_ROOT
make -C gcc java.install-common DESTDIR=$RPM_BUILD_ROOT
make -C gcc install-common DESTDIR=$RPM_BUILD_ROOT COMPILERS='jc1$(exeext) jvgenmain$(exeext)'
# install-common also installs collect2, gcov and the g++ and gfortran driver
%if %{build_cp}
rm $RPM_BUILD_ROOT%{_prefix}/bin/g++%{binsuffix}
%endif
%if %{build_fortran}
rm $RPM_BUILD_ROOT%{_prefix}/bin/gfortran%{binsuffix}
%endif
rm $RPM_BUILD_ROOT%{_prefix}/bin/gcov%{binsuffix}
rm $RPM_BUILD_ROOT%{libsubdir}/collect2
%else
make install DESTDIR=$RPM_BUILD_ROOT
%if %{build_java}
make -C gcc java.uninstall DESTDIR=$RPM_BUILD_ROOT
make -C gcc java.install-info DESTDIR=$RPM_BUILD_ROOT
rm $RPM_BUILD_ROOT%{_prefix}/bin/jcf-dump%{binsuffix}
rm $RPM_BUILD_ROOT%{_mandir}/man1/jcf-dump%{binsuffix}.1
rm $RPM_BUILD_ROOT%{libsubdir}/jc1
rm $RPM_BUILD_ROOT%{libsubdir}/jvgenmain
%endif
%endif
%endif

# Remove some useless .la files
for lib in libobjc libgfortran libgfortranbegin libmudflap libmudflapth \
    libgomp libstdc++ libsupc++ libgcj-tools libgij; do
  rm -f $RPM_BUILD_ROOT%{versmainlibdir}/$lib.la
%if %{biarch}
  rm -f $RPM_BUILD_ROOT%{versmainlibdirbi}/$lib.la
%endif
done

mkdir -p $RPM_BUILD_ROOT%{_libdir}
%if %{biarch}
%if %{build_primary_64bit}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
%else
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib64
%endif
%endif

%if %{build_ada}
mv $RPM_BUILD_ROOT%{libsubdir}/adalib/lib*-*.so $RPM_BUILD_ROOT%{_libdir}
ln -sf %{_libdir}/$(cd $RPM_BUILD_ROOT%{_libdir} && echo libgnarl-*.so) $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnarl.so
ln -sf %{_libdir}/$(cd $RPM_BUILD_ROOT%{_libdir} && echo libgnat-*.so) $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnat.so
chmod a+x $RPM_BUILD_ROOT%{_libdir}/libgna*-*.so
%endif

rm -f $RPM_BUILD_ROOT%{_prefix}/bin/c++%{binsuffix}

# Remove some crap from the .la files:
for l in `find $RPM_BUILD_ROOT -name '*.la'`; do
  echo "changing $l"
# -e '/^dependency_libs/s|%{libsubdir}/\([^.]*\)\.la |%{_libdir}/\1\.la |g'
  sed -e '/^dependency_libs/s| -L%{_builddir}/[^ ]*||g' \
      -e '/^dependency_libs/s| -L/usr/%{GCCDIST}/bin||g' \
      -e '/^dependency_libs/s|-lm \(-lm \)*|-lm |' \
      -e '/^dependency_libs/s|-L[^ ]* ||g' \
%if %{biarch}
%if %{build_primary_64bit}
      -e '/^libdir/s|%{_libdir}/32|%{_prefix}/lib|' \
      -e '/^libdir/s|lib64/\.\./||' \
%else
      -e '/^libdir/s|%{_libdir}/64|%{_prefix}/lib64|' \
%endif
%endif
      < $l  > $l.new
  mv $l.new $l
done

%if %{run_tests} 
cp `find . -name "*.sum"` ../testresults/
cp `find . -name "*.log"  \! -name "config.log" |grep -v 'acats/tests' ` ../testresults/
chmod 644 ../testresults/*
%endif
# Remove files that we do not need to clean up filelist
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{GCCDIST}-*
rm -rf $RPM_BUILD_ROOT%{libsubdir}/install-tools
rm -rf $RPM_BUILD_ROOT%{libsubdir}/install-tools
#rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig/libgcj%{binsuffix}.pc
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/root
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/curses.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/asm-*
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/linux
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/sound
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/features.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/ncurses.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/stdio.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/zutil.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/X11
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/bits
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/obstack.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include-fixed/spe.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/bits
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include-fixed/sys
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir
rm -f  $RPM_BUILD_ROOT%{_prefix}/bin/gccbug%{binsuffix}

%if !0%{?building_libjava:1}%{?building_libffi:1}
# delete compile flag tracking from crt files
crt_list=$RPM_BUILD_ROOT%{versmainlibdir}/crt*.o
%if %{biarch}
%if %{build_primary_64bit}
crt32_list=$RPM_BUILD_ROOT%{versmainlibdirbi32}/crt*.o
%else
crt64_list=$RPM_BUILD_ROOT%{versmainlibdirbi64}/crt*.o
%endif
%endif
for o in $crt_list $crt32_list $crt64_list; do
  objcopy -R ".comment.SUSE.OPTs" $o
done
%endif

%if 0%{?building_libjava:1}
# gcj -static doesn't work properly anyway, unless using --whole-archive
# let's save the space instead.
find $RPM_BUILD_ROOT -name libgcj.a \
	-o -name libgcj-tools.a \
	-o -name libgij.a \
	-o -name libgtkpeer.a \
	-o -name libjawt.a \
	-o -name libjvm.a \
	-o -name libgcj_bc.a \
  | xargs rm -f

find $RPM_BUILD_ROOT -name libgcj.spec | xargs \
  sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/'

# security files have broken install locations, also they cause conflicts
# between libgcj versions.  Simply delete them here, libgcj will use its
# defaults in this case (which is what these files contain anyway).
rm $RPM_BUILD_ROOT%{_libdir}/logging.properties
rm -r $RPM_BUILD_ROOT%{_libdir}/security
%endif

%if 0%{?building_libffi:1}
# Move libffi headers, remove empty libffi libtool file
mkdir -p $RPM_BUILD_ROOT%{_prefix}/include
mv $RPM_BUILD_ROOT%{libsubdir}/include/ffitarget.h $RPM_BUILD_ROOT%{_prefix}/include/
mv $RPM_BUILD_ROOT%{libsubdir}/include/ffi.h $RPM_BUILD_ROOT%{_prefix}/include/
rm -f $RPM_BUILD_ROOT%{mainlibdir}/libffi.la
%if %{biarch}
rm -f $RPM_BUILD_ROOT%{mainlibdirbi}/libffi.la
%endif
%endif

%if %{build_java}
%if !%{build_libjava}
rm $RPM_BUILD_ROOT%{_mandir}/man1/jv-convert%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/gcj-dbtool%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/gij%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/grmic%{binsuffix}.1
rm $RPM_BUILD_ROOT%{_mandir}/man1/gc-analyze%{binsuffix}.1
%endif
%endif
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/fsf-funding.7
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/gfdl.7
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/gpl.7
rm -f $RPM_BUILD_ROOT%{_libdir}/libiberty.a
%if %{build_nof}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/nof/libiberty.a
%endif
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libiberty.a
%else
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/libiberty.a
%endif
%endif

%if %{build_java}
%if 0%{?building_libffi:1}
%files 
%defattr(-,root,root)
%mainlib libffi.so.*

%if %{separate_biarch}
%files -n libffi43%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libffi.so.*

%endif

%files -n libffi43-devel
%defattr(-,root,root)
%{_prefix}/include/ffi.h
%{_prefix}/include/ffitarget.h
%mainlib libffi.so

%mainlib libffi.a

%if %{separate_biarch}
%files -n libffi43-devel%{separate_biarch_suffix}
%defattr(-,root,root)
%biarchlib libffi.so

%biarchlib libffi.a

%endif
%endif
%endif

%if %{run_tests}
%files -n gcc43-testresults
%defattr(-,root,root)
%doc testresults/test_summary.txt
%doc testresults/*.sum
%doc testresults/*.log
%endif

%changelog
* Tue May 22 2018 mliska@suse.cz
- Fix ICE when building a user-space project with retpolines
  [bnc#1092807].
* Fri May  4 2018 matz@suse.de
- Disable Ada on new distros, they don't provide
  gcc43-ada anymore.
* Tue Feb 13 2018 mliska@suse.cz
- Fix gcc43-mindirect-branch.diff patch as the compiler
  failed to build glibc package.
* Mon Jan 22 2018 mliska@suse.cz
- Add support for retpolines. [bnc #1074621]
  Adds gcc43-mindirect-branch.diff.
* Mon Sep 25 2017 matz@suse.de
- Add support for zero-sized VLAs and allocas with
  - fstack-clash-protection.  [bnc #1059075]
  Changes gcc43-stack-probe.diff .
* Thu Jul 27 2017 matz@suse.de
- Add support for -fstack-clash-protection.  [bnc #1039513]
  Adds gcc43-stack-probe.diff .
* Wed Jun 21 2017 matz@suse.de
- Don't request excutable stack from libffi.  [bnc #1045091]
  Adds gcc43-libffi-noexecstack.diff .
* Wed Jun 14 2017 rguenther@suse.com
- Add gcc43-bnc1044016.patch to build 32bit libgcov.a with LFS
  support.  [bnc#1044016]
* Tue Oct 11 2016 rguenther@suse.com
- Add gcc43-nvl999596.patch to fix issue with libstdc++ functional
  when an exception is thrown during construction.  [bnc#999596]
* Thu Apr 28 2016 rguenther@suse.com
- Add gcc43-bnc977654.patch to fix issue with using gcov and #pragma pack.
  [bnc#977654]
* Thu Jan 14 2016 rguenther@suse.com
- Add nvl938159.patch to fix ICE compiling AFS modules for the
  s390x kernel.  [bnc#938159]
* Mon Apr 28 2014 rguenther@suse.com
- Require libgcc_s1 instead of libgcc1.
* Fri Mar 21 2014 rguenther@suse.com
- Backport large file support from GCC 4.6.
* Tue Oct 15 2013 rguenther@suse.com
- Avoid /bin/sh pre-requirement in shared library packages by
  using %%post[un] -p.  [bnc#843331]
* Thu Jul  4 2013 matz@suse.com
- Try building libgcj43 with new distris.
* Wed Jun 26 2013 coolo@suse.com
- strip -grecord-gcc-switches from optflags
* Mon Jan 28 2013 rguenther@suse.com
- Backport fix for PR42511.  [bnc#799300]
* Mon Jan  7 2013 rguenther@suse.com
- Backport fix for PR46399.  [bnc#775482]
* Fri Nov 30 2012 rguenther@suse.com
- Fix bswap64 code generation on ppc64.  [bnc#760808]
* Sat Jul 28 2012 aj@suse.de
- Fix build with glibc 2.16 (struct siginfo is not exported anymore).
* Fri Jul 20 2012 rguenther@suse.com
- BuildRequire makeinfo only where appropriate.
* Fri Jun  1 2012 adrian@suse.de
- Exclude arm plattform from building
* Thu Apr 26 2012 rguenther@suse.com
- Update licenses to use SPDX format
* Thu Nov 10 2011 rguenther@suse.com
- Fix altivec comparison builtins.  [bnc#729378]
* Fri Oct 21 2011 mls@suse.de
- do not use /usr/src/packages in specfile
* Tue Oct 11 2011 rguenther@suse.com
- Fix ICE compiling LLVM with the patch for bnc#681566.
* Wed Oct  5 2011 rguenther@suse.com
- Revert s390-max-pending-list-length.  [bnc#722234]
* Fri Sep 16 2011 matz@suse.de
- Generate better debug info.  [bnc #681566]
* Mon Aug 15 2011 rguenther@novell.com
- Add patch for Cell reload issue.  [bnc#712118]
* Thu Jun 30 2011 rguenther@novell.com
- Fix ABI for V2DImode parameters and return values for PPC VSX.
  [bnc#702947]
- Add patch for PR38591.
* Wed May 18 2011 rguenther@novell.com
- Apply S390 patches from IBM.  [bnc#694559] [fate#311845]
* Fri Apr 15 2011 rguenther@novell.com
- Backport Large-TOC support for ppc64.  [bnc#687133] [fate#311554]
* Mon Mar 21 2011 rguenther@novell.com
- Fix debug info for typedefs of qualified types.  [bnc#675609]
* Fri Jan 21 2011 rguenther@novell.com
- Fix value-numbering with -fpreserve-function-arguments.  [bnc#665849]
- Modify bnc#623386 fix according to what is now upstream.
* Thu Jan 13 2011 rguenther@novell.com
- Add patch for PR47278.  [bnc#663013]
* Fri Sep  3 2010 rguenther@novell.com
- Add patch for PR45502.  [bnc#636961]
* Thu Aug 26 2010 rguenther@novell.com
- Add patch for SSA name coalescing bug.  [bnc#623386]
* Wed Feb 24 2010 rguenther@suse.de
- Split libffi43 build to a separate spec file.
- Add baselibs.conf as a source.
* Mon Feb 15 2010 matz@suse.de
- Fix demangling in collect2 error messages for char16/char32.
  [bnc #579916]
* Fri Jan 22 2010 rguenther@suse.de
- Add patch to fix Power7 xssqrtdp instruction.  [bnc#572812]
* Mon Jan 11 2010 rguenther@suse.de
- Add patches for PR42429 and PR42614.
* Fri Nov 20 2009 rguenther@suse.de
- Re-diff patches to apply without fuzz.
* Thu Nov 19 2009 rguenther@suse.de
- Enable decimal floating point for s390(x).
* Mon Oct 19 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r152973).  [bnc#548080]
* Fri Oct 16 2009 rguenther@suse.de
- Drop in Power7 patches for SLE11 SP1 from IBM.  [bnc#547299]
  [fate#307034] [fate#201762]
* Tue Oct 13 2009 rguenther@suse.de
- Drop in S/390 patches for SLE11 SP1 from IBM.
* Mon Sep 21 2009 rguenther@suse.de
- Backport patch for avoiding SPU micrococded instructions.  [bnc#434505]
* Tue Aug  4 2009 rguenther@suse.de
- Update to GCC 4.3.4 release.  [bnc#504421]
- Disable -Wl,--as-needed.
* Mon Aug  3 2009 rguenther@suse.de
- Package cpuid.h.  [bnc#527433]
* Tue Jul 14 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r149624).
* Wed Jul  1 2009 rguenther@suse.de
- Add patch for PR40585.  [bnc#516424]
* Wed Jun 17 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r148625).
* Mon May 25 2009 rguenther@suse.de
- Add patch for PR32044.  [bnc#495844]
* Wed May 20 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r147732).
* Fri May 15 2009 rguenther@suse.de
- Split PR27799 patch.
- Add patch for PR40141.
- Fix testcase for PR36745.
* Fri May  8 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r147281).
- Disable cross compiler spec file generation.
* Mon Apr 20 2009 rguenther@suse.de
- Add patch for PR39675.  [bnc#492696]
* Sat Apr 18 2009 rguenther@suse.de
- Adjust Ada BuildRequires check.
* Mon Mar 16 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r144878).
- Add patch for PR39175.  [bnc#472835]
* Mon Jan 26 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r143673).  Includes GCC 4.3.3 release.
* Mon Jan 19 2009 schwab@suse.de
- Fix invalid merge section.
* Fri Jan 16 2009 rguenther@suse.de
- Obsolete libgcc-64bit from ppc64 libgcc43 package and libstdc++-64bit
  from ppc64 libstdc++43 package.
- Add patch to avoid passing --gdwarf2 to the assembler on -g0.
* Mon Jan 12 2009 rguenther@suse.de
- Update to gcc-4_3-branch head (r143290).
- Drop local patches for PRs 36438, 37868, 38051, 38171, 38752 and 38000.
* Mon Jan 12 2009 rguenther@suse.de
- Correct decimal floating-point macros in <float.h> to match
  the final version of ISO C TR24732.  [bnc#464739]
- Add patch for PR38000, C++ headers malefunction with the use
  of -isystem.  [bnc#465348]
* Thu Jan  8 2009 rguenther@suse.de
- Fix crash during unwinding on ppc64.  [bnc#440482]
* Wed Jan  7 2009 rguenther@suse.de
- Do not link ecj1 against libgcj.
- Fix TOC clobbering on ppc.  [bnc#428413]
- Add patch for PR38171.  [bnc#457593]
- Add patch for PR38752.  [bnc#459344]
* Thu Nov 27 2008 rguenther@suse.de
- Add capability to process default_spec from a defaults.spec specs
  file if that exists.
* Fri Nov 21 2008 matz@suse.de
- Fix a segfault.  [bnc #447669]
* Fri Nov 21 2008 rguenther@suse.de
- Back to z900 default architecture and z9-109 tuning for System-z.
* Mon Nov 17 2008 rguenther@suse.de
- Backport patch for PR38051.  [ggo#38169]
- Filter out -m32/-m64 from RPM_OPT_FLAGS.
* Thu Nov 13 2008 matz@suse.de
- Pass build-id to linker also on ppc/ppc64.
* Mon Nov 10 2008 matz@suse.de
- Make libgcc43 also provide/obsolete libgcc33.  [bnc #442802]
* Fri Nov  7 2008 rguenther@suse.de
- Disable profiledbootstrap.
* Fri Nov  7 2008 rguenther@suse.de
- Add patch for PR37868.  [bnc#442276]
- Add uchar.h header.  [fate#303956]
* Thu Nov  6 2008 rguenther@suse.de
- Add patch for PR36438.  [bnc#442192]
* Mon Nov  3 2008 rguenther@suse.de
- Fix Cell ABI problems.  [bnc#441016]
- Move to new Cell cross compiler directory layout.
- Add patch to fix --with-sysroot for Cell.
* Fri Oct 24 2008 schwab@suse.de
- Fix indirect call profiling on ia64 (PR32277).
* Wed Oct 22 2008 matz@suse.de
- Update to gcc-4_3-branch head (141291).
  * Fixes PR37603, PR37731, PR35437, PR37102.
- Build crtend*.o without unwind tables.
* Wed Oct 15 2008 rguenther@suse.de
- Fix version reporting for SLES, now also for openSUSE.  [bnc#363219]
- Fix use of DFP instructions with -msoft-float on System-z.  [bnc#436041]
- Change default architecture to z9-109 for System-z.
- Change default tuning to z10 for System-z.
- Enable final C++ mangling for UTF-16.  [fate#303956]
* Mon Oct 13 2008 rguenther@suse.de
- Add missing SPU intrinsics.  [bnc#434500]
* Thu Oct  2 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (140831).
  * Drop now unneeded patches.
- Adopt patches from Fedora10
  * Add fixes for PR34037, PR37189 and revert the fix for PR36741.
  * Fix omp.h header for the 32/64bit multilib.
  * Enable -mno-sse to optimize varargs stack usage.
- Enable proper java home for libgcj.  [bnc#303904]
* Sat Sep 20 2008 rguenther@suse.de
- Drop patch for bnc#425800 again.
- Disable fortran for static crosses.  [bnc#428329]
* Tue Sep 16 2008 rguenther@suse.de
- Put the compile flags section at the end of the file.  Fixes
  wrong code for glibc startfiles.
- Apply build-id and compile flags recording only for suse_version > 1100.
- Add backport patches for UTF-16 support.  [fate#303956]
- Change .comment.SuSE.OPTs to .comment.SUSE.OPTs.
- Add patch to document -march=z10 option for s390.
* Mon Sep 15 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r140371).
- Add patch for PR35620.  [bnc#425697]
- Add backport patches for powerpc bugfixes from GCC trunk.
  [bnc#425806, bnc#425803, bnc#425800, bnc#425783, bnc#425784, bnc#425788,
  bnc#425789, bnc#425790, bnc#425791, bnc#425794, bnc#425798, bnc#425799,
  bnc#426087]
- Add patch to fix invalid GIMPLE from SRA.  [bnc#423594]
- Fix libgcj43 build.
- Make compile flags comment section non-allocated.
* Fri Sep 12 2008 dmueller@suse.de
- track compile flags in ELF objects (fate #300498)
* Wed Sep 10 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r140201).
  * adds requested Cell bugfix.
- Add patch for Cell optimizations.
- Passs --build-id to linker.
* Thu Sep  4 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r139985).
- Do not build static libjava.
* Mon Sep  1 2008 rguenther@suse.de
- Add patch to adjust GCC version string for SLES.  [bnc#363219]
- Forward port patch to preserve function arguments for debug info
  from SLE10.  [fate#301921]
- Add patch for POWER7 support.  [fate#304134]
- Disable mudflap support by default, do not build libmudflap.
- Add patch for PR27975.  [fate#300955]
* Thu Aug 28 2008 rguenther@suse.de
- Update to GCC 4.3.2 release (r139672).  [bnc#363219]
- Revert -mcpu=mpower4 change for ppc, keep it for ppc64.  [bnc#408808]
* Thu Aug 21 2008 rguenther@suse.de
- Update patch for PR27799.  [bnc#419260]
* Mon Aug 18 2008 rguenther@suse.de
- Add patch for the z10 pipeline description.  [bnc#417534, fate#304071]
* Fri Aug 15 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r139129).
- Make -mcpu=power4 the default.  [bnc#417566]
* Mon Aug 11 2008 rguenther@suse.de
- Add patch for PR36998.  [bnc#416157]
* Tue Aug  5 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r138797).
- Add patches for context sensitive vector keyword support (IBM).
- Add patch for PR36613.
* Fri Jul 25 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r138144).
- Add patches for early complete loop unrolling.
* Mon Jul 21 2008 rguenther@suse.de
- Add patches to support SSE5 vectorized shift instructions.
- Add patch for PR36765.
* Tue Jul 15 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r137837).
- Make it build on SLES9.
- Enable C++ and GFortran for the spu cross.
- Add patch for PR36745.
- Add patch for PR36822.  [bnc#408075]
* Thu Jul  3 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r137416).
- Add patch to support Intel AES intrinsics.  [fate#303993]
- Add patches to support the IBM z10 architecture.  [fate#304071]
* Wed Jun 25 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r137104).  [bnc#402268]
* Fri Jun 13 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r136744).
- Add patch for PR36519.  [ggo#36519]
* Mon Jun  9 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r136588).
- Includes GCC 4.3.1 release.
- Add patch for PR36474.  [ggo#36474]
* Tue May 27 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r136151).
- Add patches for PRs 36262 and 36291.  [ggo#36262, ggo#36291]
- Add patch for PR36343.  [ggo#36343]
- Add patch for better supporting suffixed Ada drivers and tools.
- Always set sysroot for spu target.  [bnc#397825]
* Thu May 15 2008 rguenther@suse.de
- Add patch to fix memtest miscompilation.  [ggo#36227]
- Add patch for PR34330 and PR36244.  [ggo#34330, ggo#36244]
* Fri May  9 2008 rguenther@suse.de
- Add patch for PR36187.  [bnc#388664]
* Wed May  7 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r135036).  [ggo#36077, ggo#36137]
- Adds warning for undefined behavior on pointer overflow.
* Fri Apr 25 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r134659).  [ggo#35773, ggo#35907, ggo#35695,
  ggo#36008, ggo#36015, ggo#36017]
- Add patch to fix latent aliasing bug.
* Thu Apr 10 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r134138).  [ggo#35833, ggo#35900]
* Thu Apr 10 2008 ro@suse.de
- added baselibs.conf file to build xxbit packages
  for multilib support
* Tue Apr  1 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r133790).
- Remove use of %%run_ldconfig.
- Add fix for K&R missed prototype warning.  [bnc#376194]
* Thu Mar 27 2008 schwab@suse.de
- Add fix for PR35695.
* Fri Mar 14 2008 matz@suse.de
- Hide some more gcov functions.
* Tue Mar 11 2008 rguenther@suse.de
- Add patch for PR35469.
- Fix two bugs in the patches for PR34043.
* Thu Mar  6 2008 rguenther@suse.de
- Update to GCC 4.3.0 release.
- Add patches for PR35472 and PR34989.
- Add patches for AMD requested feature.  [ggo#34043]
* Fri Feb 22 2008 rguenther@suse.de
- Deal with fixed wchar.h on old glibc systems.
* Mon Feb 18 2008 rguenther@suse.de
- Update to gcc-4_3-branch head (r132521).  [bnc#355496, bnc#354113]
* Sat Feb 16 2008 schwab@suse.de
- Make sure the icecream env contains all needed shared libs.
* Tue Feb 12 2008 rguenther@suse.de
- Update to SVN trunk head (r132345).
- Add patches to versionize info documentation and locales.
* Fri Feb  1 2008 rguenther@suse.de
- Fix libgcj_bc packaging.
- Add workaround for PR35056.  [bnc#358319]
* Mon Jan 28 2008 rguenther@suse.de
- Update to SVN trunk head (r131976).  [bnc#355254]
* Tue Jan 22 2008 rguenther@suse.de
- Update to SVN trunk head (r131724).  [#343712]
- Add patch for PR34829.
- Add -Wunprototyped-calls and enable it with -Wall.
* Wed Jan 16 2008 rguenther@suse.de
- Update to SVN trunk head (r131592).  [#337901, #354119]
* Wed Jan  2 2008 rguenther@suse.de
- Update to SVN trunk head (r131254).
- Drop no longer required patches.
- Add patch for PR33960.
* Mon Dec 10 2007 rguenther@suse.de
- Add patches for PR34391 and PR34302.
* Wed Dec  5 2007 rguenther@suse.de
- Add patch for PR34334.
* Thu Nov 29 2007 rguenther@suse.de
- Update to SVN trunk head (r130511).  [#340981]
- Add patch for PR33763.  [#344524]
- Add patch for PR34244.  [#342603]
- Add patch for PR34238.
* Fri Nov 23 2007 rguenther@suse.de
- Build gcc43-java from libgcj43.spec.
- Shuffle binaries back from gcc43-gij to gcc43-java retaining
  only classpath tools in gcc43-gij.
- Add libgcj43-jar package required by libgcj43-devel and only
  recommended by libgcj43.
- Fix icecream cross install directory.
* Thu Nov 22 2007 rguenther@suse.de
- Simplify biarch rpm-macros.
- Add patch for PR34176.  [#342236]
- Add another alias fix.
* Tue Nov 20 2007 rguenther@suse.de
- Update to SVN trunk head (r130276).
- Revert fix for PR25950.
- Add patch for PR34148.
* Tue Nov 13 2007 rguenther@suse.de
- Change directories used in GCC install to only contain major and
  minor version, not patchlevel.
* Fri Nov  9 2007 rguenther@suse.de
- Update to SVN trunk head (r130038).
- Enable spu and avr cross targets.
- Fix i386 and ppc64 icecream cross targets.
- Disable alpha and arm icecream cross targets.
- Fix icecream cross target search path issues.
- Add README.First-for.SuSE.packagers as extra source and update it.
- Depend on gcc43-ada.
* Thu Nov  8 2007 rguenther@suse.de
- Enable icecream backends.
* Mon Nov  5 2007 rguenther@suse.de
- Fix ia64 stack-protector patch.
- Add patch for PR32260.
* Tue Oct 30 2007 rguenther@suse.de
- Fix rpmlint override files.
* Mon Oct 29 2007 rguenther@suse.de
- Add patch for PR33871, linker errors with anonymous namespaces and
  typeinfo.
* Wed Oct 24 2007 rguenther@suse.de
- Add patch for PR33870, sqlite miscompile.
- Add patch for PR33868, memory usage regression on glibc testsuite.
* Thu Oct 18 2007 rguenther@suse.de
- Add back patch for PR27880.  Fixes missing _Unwind_GetIPInfo
  symbol in static libgcc on ia64.
- Add patch for PR33168, fixes ppc64 bootstrap failure.
- Add patch for PR33608, fixes Ada build on ia64.  Re-enable Ada for ia64.
- Work around PR33857, allow building Ada with old version alone.
* Tue Oct 16 2007 rguenther@suse.de
- Update to SVN trunk head (r129378).
* Mon Oct 15 2007 rguenther@suse.de
- Update to SVN trunk head (r129351).
* Fri Oct 12 2007 rguenther@suse.de
- Package modified eclipse frontent jar.
- Remove ecj-bootstrap BuildRequires.
* Thu Oct 11 2007 rguenther@suse.de
- Update to SVN trunk head (r129228).
* Tue Oct  9 2007 rguenther@suse.de
- Update to SVN trunk head (r129166).
- Add patch for PR33692.
* Mon Oct  8 2007 rguenther@suse.de
- Update to SVN trunk head (r129130).
* Tue Oct  2 2007 rguenther@suse.de
- Update to SVN trunk head (r128956).
- Obsoletes fixes PR33146, PR33552, PR30375, PR33560 and linker
  version detection.
* Mon Oct  1 2007 rguenther@suse.de
- Disable ada for ia64.
* Thu Sep 27 2007 rguenther@suse.de
- Add patch for PR33552, also fixes reload failure for i586 glibc.
* Wed Sep 26 2007 rguenther@suse.de
- Add patch for PR30375 and PR33560.
* Mon Sep 24 2007 rguenther@suse.de
- Fix binutils version detection.
* Fri Sep 21 2007 rguenther@suse.de
- Update to SVN trunk head (r128649).
- Add patch for PR33146.
* Mon Sep 17 2007 rguenther@suse.de
- Update to SVN trunk head (r128539).
- Drop patch for PR32756.
- Revert r127960.
* Thu Aug 30 2007 rguenther@suse.de
- Add patch for PR32756.
* Fri Aug 24 2007 rguenther@suse.de
- Update to SVN trunk head (r127773).
* Fri Aug 24 2007 rguenther@suse.de
- Allow disabling of C++ and ObjC.
- Add rpmlint exceptions for libraries.
* Mon Aug 20 2007 rguenther@suse.de
- Delete fix-included sound headers.
* Wed Jul 25 2007 rguenther@suse.de
- Update with specfile changes that went into the gcc42 package.
- Update to SVN trunk head (r126913).
* Wed May  9 2007 rguenther@suse.de
- Update to SVN trunk head (r124570).
- Add unzip BuildRequires for libjava.
- No longer package precompiled headers for libstdc++.
* Tue Mar 27 2007 rguenther@suse.de
- Update to SVN trunk head (r123255).
- Remove %%versionspecificlibs stuff.
* Thu Nov 16 2006 rguenther@suse.de
- Update to SVN 4.2 branch head.
- Remove patch for PR26898 again.
* Fri Oct 20 2006 rguenther@suse.de
- Update to SVN 4.2 branch head, fixes some remaining aliasing miscompiles.
- Fix libgcj.pc install.
- Update AMD-0201 patch.
* Tue Oct 17 2006 rguenther@suse.de
- Update to SVN head.
- Add AMD-0201.
- Add other minor improvements.
* Tue Sep 19 2006 rguenther@suse.de
- New gcc42-gij package.
- Adjust libgcj so version.
- Add proper Obsoletes to virtual Provides and gcc41 packages to
  make rpm install work.
- Kill @gcc_suffix@.
* Mon Sep 18 2006 rguenther@suse.de
- Update to SVN head.
* Mon Sep  4 2006 rguenther@suse.de
- Fix libgcj packaging.
- Run the testsuite from the libgcj package and package results
  in gcc42-testresults.
* Tue Aug 29 2006 rguenther@suse.de
- Update to SVN head.
- Remove patch for bogus warning which is fixed upstream already.
- Fix URL for bugreporting, use http://bugs.opensuse.org instead of
  http://www.suse.de/feedback.
- No longer package gccbug script which led to feedback@suse.de which no
  longer exists.
* Tue Aug 22 2006 rguenther@suse.de
- Forward port spec file changes from gcc41 package.
- libobjc changed .so version.
* Tue Aug 15 2006 schwab@suse.de
- Fix infinite loop (PR28672).
* Tue Aug 15 2006 rguenther@suse.de
- New gcc42 package.
